// ****************************************************************************
//
//          Aevol - An in silico experimental evolution platform
//
// ****************************************************************************
//
// Copyright: See the AUTHORS file provided with the package or <www.aevol.fr>
// Web: http://www.aevol.fr/
// E-mail: See <http://www.aevol.fr/contact/>
// Original Authors : Guillaume Beslon, Carole Knibbe, David Parsons
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef AEVOL_GAUSSIAN_H_
#define AEVOL_GAUSSIAN_H_

#include "PhenotypicTargetConstituent.h"

#include <cmath>
#include <iostream>

namespace aevol {

class Gaussian: public PhenotypicTargetConstituent {
 public :
  Gaussian() = default;
  Gaussian(double height, double mean, double width): PhenotypicTargetConstituent(height, mean, width) {}
  Gaussian(const Gaussian& model) = default;
  virtual ~Gaussian() {}

  static auto make_from_checkpoint(std::istream& is) -> std::unique_ptr<Gaussian>;
  auto make_copy() const -> std::unique_ptr<PhenotypicTargetConstituent> override;

  auto keywd() const -> std::string override { return "GAUSSIAN"; }

  auto compute_y(double x) const -> double override {
    return height_ * exp(-(x - mean_) * (x - mean_) / (2 * width_ * width_));
  }
};

inline auto Gaussian::make_from_checkpoint(std::istream& is) -> std::unique_ptr<Gaussian> {
  auto gaussian = std::make_unique<Gaussian>();
  is >> gaussian->height_ >> gaussian->mean_ >> gaussian->width_;
  return gaussian;
}

inline auto Gaussian::make_copy() const -> std::unique_ptr<PhenotypicTargetConstituent> {
  return std::make_unique<Gaussian>(*this);
}

} // namespace aevol

#endif // AEVOL_GAUSSIAN_H_
